Package: sdm
Type: Package
Title: Species Distribution Modelling
Version: 1.2-59
Date: 2025-07-13
Authors@R: c(person(given = "Babak",
                      family = "Naimi",
                      role = c("aut", "cre"),
                      email = "naimi.b@gmail.com",
                      comment = c(ORCID = "0000-0001-5431-2729")),
               person(given = c("Miguel", "B."),
                      family = "Araujo",
                      role = "aut"))
Depends: methods, R (>= 3.5.0), terra
Imports: sp, raster
Suggests: R.rsp, shinyBS, shiny, dismo
Description: An extensible framework for developing species distribution
    models using individual and community-based approaches, generate ensembles of
    models, evaluate the models, and predict species potential distributions in
    space and time. For more information, please check the following paper:
    Naimi, B., Araujo, M.B. (2016) <doi:10.1111/ecog.01881>.
License: GPL (>= 3)
URL: https://www.biogeoinformatics.org
VignetteBuilder: R.rsp
NeedsCompilation: no
Packaged: 2025-07-13 00:38:49 UTC; naimi001
Author: Babak Naimi [aut, cre] (ORCID: <https://orcid.org/0000-0001-5431-2729>),
  Miguel B. Araujo [aut]
Maintainer: Babak Naimi <naimi.b@gmail.com>
Repository: CRAN
Date/Publication: 2025-07-13 02:30:02 UTC
Built: R 4.3.3; ; 2025-07-14 22:23:58 UTC; unix

import(sp,methods)
importFrom("graphics", "abline", "legend", "par", "points","lines","boxplot","barplot","arrows","segments","text","axis")
importFrom("grDevices", "colorRampPalette")
importFrom("stats", "as.formula", "cor", "cov","cor.test","coefficients", "density","formula", "glm",
             "lm","kmeans","mahalanobis","median","model.frame","model.matrix","optim","plogis","poly","princomp","predict.glm","qt","quantile",
           "supsmu", "sd","terms","terms.formula","wilcox.test")
importFrom("utils", "combn", "data", "read.csv","object.size","install.packages","remove.packages","write.csv")
importFrom("parallel", "makeForkCluster", "makePSOCKcluster", "detectCores","clusterExport","clusterEvalQ","stopCluster","parLapply")
importFrom("raster", "addLayer","brick","calc","coordinates","density","extent","extension","getValues","nlayers","predict","projection","projection<-", "raster", "stack" ,"setZ","sampleRandom",
           "sampleStratified","scale","setValues","Which")
importFrom("terra", "adjacent","app","as.data.frame","blocks","boxplot","cells","cellFromXY","cellFromRowCol" ,"concats","crds","crs<-","crs","ext<-","extract","freq","global","gridDist","gridDistance","geom","hasValues","head","ifel","mean","median","metags<-","layerCor","ncell","nlyr","predict","project","rast","readStart","readStop","readValues","scale","stdev","set.values","sources","spatSample","subset","tapp","trim","values","vect","update","weighted.mean","writeRaster","writeStart","writeStop","writeValues","xyFromCell")

#exportClasses(sdmdata, sdmFormula,sdmEvaluate,sdmModels,sdmCorrelativeMethod,.pcaObject)
#exportMethods(sdmData,sdm,sdmSetting,evaluates,roc,getRoc,add,getmethodNames,getmethod,getModelInfo,getModelId,
#              getEvaluation,read.sdm,write.sdm,installAll,gui,getVarImp,ensemble,subset,rcurve,getResponseCurve,niche,pca)
exportPattern("^[[:alpha:]]+")

# Author: Babak Naimi, naimi.b@gmail.com
# Date (last update):  Nov. 2019
# Version 1.2
# Licence GPL v3

#-------------
methodInfo <- list(name=c('brt','BRT','gbm','GBM'),
                  packages='gbm',
                  modelTypes = c('pa','pb','ab','n'),
                  fitParams = list(formula='standard.formula',data='sdmDataFrame'),
                  fitSettings = list(distribution='bernoulli',
                                     n.trees=1000,
                                     interaction.depth=4,
                                     n.minobsinnode = 10,
                                     shrinkage = 0.001,
                                     bag.fraction = 0.5,
                                     train.fraction = 1.0,
                                     cv.folds=0,
                                     keep.data = TRUE,
                                     verbose = "CV",
                                     class.stratify.cv=NULL),
                  fitFunction = 'gbm',
                  settingRules = function(x='sdmVariables',f='fitSettings') {
                    #if (!is.null(userSetting)) fitSettings <- .assign(fitSettings,userSettings)
                    #else if (x@distribution == 'ab') fitSettings[['distribution']] <- "poisson"
                    #else if (x@distribution == 'n') fitSettings[['distribution']] <- "multinomial"
                    if (x@distribution %in% c('poisson','multinomial')) {
                        f[['distribution']] <- x@distribution
                    }
                    if (x@number.of.records[1] < 55) {
                      f[['n.minobsinnode']] <- max(floor(x@number.of.records[1] / 5),3)
                      if (x@number.of.records[1] < 30) f[['bag.fraction']] <- 0.9
                    }
                    list(fitSettings=f)
                  },
                  tuneParams = NULL,
                  predictParams=list(object='model',newdata='sdmDataFrame'),
                  predictSettings=list(n.trees=1000,type='response'),
                  predictFunction='predict.gbm',
                  #------ metadata (optional):
                  title='Boosted Regression Trees',
                  creator='Babak Naimi',
                  authors=c('Greg Ridgeway'), # authors of the main method
                  email='naimi.b@gmail.com',
                  url='http://r-gis.net',
                  citation=list(bibentry('Article',title = "A working guide to boosted regression trees",
                                         author = as.person("J. Elith [aut], J. R. Leathwick [aut], T. Hastie [aut]"),
                                         year = "2008",
                                         journal = "Journal of Animal Ecology",
                                         number="77",
                                         pages="802-813",
                                         publisher="Wiley Online Library")
                  ),
                  description='Fits Boosting regression trees (BRT), called also generalized boosting regression model (GBM). Boosting is the process of iteratively adding basis functions in a greedy fashion so that each additional basis function further reduces the selected loss function [see the help for gbm function in gbm package]'
)
#------------

# Author: Babak Naimi, naimi.b@gmail.com
# Date (last update) :  July 2017
# Version 1.2
# Licence GPL v3

#-------------
methodInfo <- list(name=c('maxent','Maxent','MAXENT','entropy','maxentropy'),
                   packages=c('dismo','rJava'),
                   modelTypes = c('pb'),
                   fitParams = list(formula='standard.formula',data='sdmDataFrame'),
                   fitSettings = list(beta=1,prevalence=0.5,feat='autofeature',args=NULL),
                   fitFunction = '.maxent',
                   settingRules = NULL,
                   tuneParams = NULL,
                   predictParams=list(object='model',x='sdmDataFrame'),
                   predictSettings=NULL,
                   predictFunction='predict',
                   #------ metadata (optional):
                   title='Maxent',
                   creator='Babak Naimi',
                   authors=c('Steven Phillips and Robert J. Hijmans'), # authors of the main method
                   email='naimi.b@gmail.com',
                   url='http://r-gis.net',
                   citation=list(bibentry('Article',title = "Maximum entropy modeling of species geographic distributions",
                                          author = as.person("S. J. Phillips [aut], R.P. Anderson [aut], R.E. Schapire [aut]"),
                                          year='2006',
                                          number='190',
                                          pages='231-259',
                                          journal = "Ecological Modelling"
                                          
                   )
                   ),
                   description="Build a 'MaxEnt' (Maximum Entropy) species distribution model."
)

# Author: Babak Naimi, naimi.b@gmail.com
# Date (last update):  Dec. 2020
# Version 1.0
# Licence GPL v3

#-------------
methodInfo <-list(name=c('glmpoly','glmpolynomial','glmp'),
                  packages='stats',
                  modelTypes = c('pa','pb','ab','n'),
                  fitParams = list(v='sdmVariables',data='sdmDataFrame'),
                  fitSettings = list(family=binomial(link='logit'),degree=3,weights=NULL,model=FALSE),
                  fitFunction = function(v,data,degree=3,...) {
                    .f <- .getFormula.glmPoly(n=c(v@response,v@variables$numeric),nFact = v@variables$nFact,degree=degree)
                    glm(formula = .f, data = data,...)
                  },
                  settingRules = function(x='sdmVariables',f='fitSettings') {
                    if (x@distribution %in% c('poisson','multinomial')) {
                      f[['family']] <- x@distribution
                    }
                    list(fitSettings=f)
                  },
                  tuneParams = NULL,
                  predictParams=list(object='model',newdata='sdmDataFrame'),
                  predictSettings=list(type='response'),
                  predictFunction='predict.glm',
                  #------ metadata (optional):
                  title='Generalized Linear Model (Polynomial)',
                  creator='Babak Naimi',
                  authors=c('R Core team'), # authors of the main method
                  email='naimi.b@gmail.com',
                  url='http://r-gis.net',
                  citation=list(bibentry('book',title = "Generalized linear models",
                                         author = as.person("P. McCullagh [aut], J. A. Nelder [aut]"),
                                         year = "1989",
                                         publisher = "Chapman and Hall",
                                         address = "London")
                  ),
                  description='glm is used to fit generalized linear models, specified by giving a symbolic description of the linear predictor and a description of the error distribution [see the help for glm function in stats package]'
)
#------------

# Author: Babak Naimi, naimi.b@gmail.com
# Date (last update):  Nov. 2021
# Version 1.1
# Licence GPL v3

#-------------
methodInfo <- list(name=c('ranger','rangerRF','rangerForest'),
                   packages='ranger',
                   modelTypes = c('pa','pb','ab','n'),
                   fitParams = list(formula='standard.formula',data='sdmDataFrame'),
                   fitSettings = list(num.trees=1000,
                                      mtry=NULL,
                                      importance='none',
                                      probability=TRUE,
                                      quantreg=FALSE,
                                      keep.inbag = FALSE,
                                      num.threads=1,
                                      verbose = FALSE
                   ),
                   fitFunction = 'ranger',
                   settingRules = NULL,
                   tuneParams = NULL,
                   predictParams=list(object='model',data='sdmDataFrame'),
                   predictSettings=list(type='response',num.threads=1,se.method = "infjack",verbose=FALSE,seed=NULL),
                   predictFunction=function(object,data,type,num.threads,se.method,verbose,seed) {
                     predict(object,data=data,type=type,num.threads=num.threads,verbose=verbose,seed=seed)$predictions
                   },
                   #------ metadata (optional):
                   title='Random Forest (Ranger)',
                   creator='Babak Naimi',
                   authors=c('Marvin N. Wright'), # authors of the main method
                   email='naimi.b@gmail.com',
                   url='http://r-gis.net',
                   citation=list(bibentry('Article',title = " ranger: A fast implementation of random forests for high dimensional data in C++ and R",
                                          author = as.person("M.N. Wright [aut]"),
                                          year = "2017",
                                          journal = "J Stat Softw",
                                          number="77",
                                          pages="1-17"
                   )
                   ),
                   description="a fast implementation of random forests (Breiman 2001) or recursive partitioning, particularly suited for high dimensional data."
)

library(shiny)
library(shinyFiles)
library(DT)
library(leaflet)
ui <- fluidPage(
  tags$head(
   tags$style(HTML('.container { background-color: #fff; border:3px solid #ccc; width:300px; height: 200px; overflow-y: scroll; }
                   .checkboxes {
    columns: 4 8em;
                   }'))
  ),
  
  img(src="sdm_design.png",height=300,width="100%"),
  fluidRow(
    .collapsePanel("Data input",
                   column(4,
                          wellPanel(
                            tags$p('Select the training file:'),
                            textInput('trainFileName','Training'),
                            shinyFilesButton("trainFile","File select","training file",FALSE)
                          )
                          ),
                   column(4,
                          wellPanel(
                            tags$p('Select the predictor file(s) (optional):'),
                            textInput('predFileNames','Predictors'),
                            shinyFilesButton("predFiles","File(s) select","predictor files",TRUE)
                          )
                   ),
                   column(4,
                          wellPanel(
                            tags$p('Select the test file (optional):'),
                            textInput('testFileName','Test'),
                            shinyFilesButton("testFile","File select","test file",FALSE)
                          )
                   )
                  )
   
    
  ),
  fluidRow(
    .collapsePanel("Data Settings",
                   column(4,wellPanel(style = "background-color: #ffffff;",tags$div(uiOutput("dynSpecies"))))
    ),
    #column(5,wellPanel(style = "background-color: #ffffff;",tags$div(uiOutput("dynCheck"),class='container')))
    column(5,wellPanel(style = "background-color: #003333; color: #ffffff",tags$div(uiOutput("dynPreds")))),
    column(5,wellPanel(style = "background-color: #003333; color: #ffffff",tags$div(DT::dataTableOutput('tbl'))))
    
    # column(5,wellPanel(HTML('<div class="container">
    # <input type="checkbox" /> This is checkbox <br />
    #                         <input type="checkbox" /> This is checkbox <br />
    #                         <input type="checkbox" /> This is checkbox <br />
    #                         <input type="checkbox" /> This is checkbox <br />
    #                         <input type="checkbox" /> This is checkbox <br />
    #                         <input type="checkbox" /> This is checkbox <br />
    #                         <input type="checkbox" /> This is checkbox <br />
    #                         <input type="checkbox" /> This is checkbox <br />
    #                         <input type="checkbox" /> This is checkbox <br />
    #                         <input type="checkbox" /> This is checkbox <br />
    #                         </div>')))
  ),
  fluidRow(HTML('<table>
<tbody>
                <!-- What should I use here to add a question with the instructions? -->
                <tr>
                <th>watches</th>
                <th>jewerly</th>
                <th>jewerly</th>
                </tr>
                <tr>
                <td>
                <input type="checkbox" name="utType1[]" value="e" />Something </br>
                <input type="checkbox" name="utType1[]" value="e" />Something </br>
                <input type="checkbox" name="utType1[]" value="e" />Something </br>    
                <input type="checkbox" name="utType1[]" value="e" />Something </br> 
                </td>
                <td>
                <input type="checkbox" name="utType1[]" value="e" />Something </br>
                <input type="checkbox" name="utType1[]" value="e" />Something </br>
                <input type="checkbox" name="utType1[]" value="e" />Something </br>    
                <input type="checkbox" name="utType1[]" value="e" />Something </br> 
                </td>
                <td>
                <input type="checkbox" name="utType1[]" value="e" />Something </br>
                <input type="checkbox" name="utType1[]" value="e" />Something </br>
                <input type="checkbox" name="utType1[]" value="e" />Something </br>    
                <input type="checkbox" name="utType1[]" value="e" />Something </br> 
                </td>
                </tr>
                <!-- What should I use here to add a question with the instructions? -->
                <tr>
                <th>watches</th>
                <th>jewerly</th>
                <th>jewerly</th>
                </tr>
                <tr>
                <td>
                <input type="checkbox" name="utType1[]" value="e" />Something </br>
                <input type="checkbox" name="utType1[]" value="e" />Something </br>
                <input type="checkbox" name="utType1[]" value="e" />Something </br>    
                <input type="checkbox" name="utType1[]" value="e" />Something </br> 
                </td>
                <td>
                <input type="checkbox" name="utType1[]" value="e" />Something </br>
                <input type="checkbox" name="utType1[]" value="e" />Something </br>
                <input type="checkbox" name="utType1[]" value="e" />Something </br>    
                <input type="checkbox" name="utType1[]" value="e" />Something </br> 
                </td>
                <td>
                <input type="checkbox" name="utType1[]" value="e" />Something </br>
                <input type="checkbox" name="utType1[]" value="e" />Something </br>
                <input type="checkbox" name="utType1[]" value="e" />Something </br>    
                <input type="checkbox" name="utType1[]" value="e" />Something </br> 
                </td>
                </tr>
                </tbody>
                </table>')),
  sidebarPanel(
    radioButtons('format','Input Train Data Format',c('CSV','SHP')),
    hr(),
    selectizeInput("train","Select Train Dataset:","NULL"),
    selectizeInput("predictors","Select Raster Predictors file","NULL"),
    checkboxGroupInput("methods","Methods",c("GLM","GAM","BRT","RF","SVM","MARS","NNet","Bioclim","Domin","Mahalanobis","Maxent","Maxlike","Ensemble"),inline=T, selected="GLM"),
    hr(),
    checkboxGroupInput("repMethod","Replication Methods",c("Subsampling","Bootsraping","Cross-Validation"),selected="Subsampling"),
    numericInput("replicates","Replicates",1,min=1),
    numericInput("cv.folds","CV.Folds",5,min=1),
    sliderInput('test.percent','Test persentage',0,100,30,1),
    #bsCollapsePanel("test")
    #bsCollapsePanel("Data Settings",
    #                 radioButtons('format','Input Train Data Format',c('CSV','SHP')),
    #                 hr(),
    #                 selectizeInput("train","Select Train Dataset:","NULL"),
    #                 selectizeInput("predictors","Select Raster Predictors file","NULL"),
    #                 br(),
    #                 br()
    #                 
    # ),
    # bsCollapsePanel('test',
    #                 sliderInput('a','aa',min = 0,max = 10,1)
    #                 )
    #HTML(paste0(p1,p2,p3))
    #bsCollapsePanel('ttt')
    #shinyFilesButton('files', label='File select', title='Please select a file', multiple=FALSE)
    .collapsePanel("Models Settings",
                   checkboxGroupInput("methods1","Methods",c("GLM","GAM","BRT","RF","SVM","MARS","NNet","Bioclim","Domin","Mahalanobis","Maxent","Maxlike","Ensemble"),inline=T, selected="GLM"),
                   hr(),
                   checkboxGroupInput("repMethod1","Replication Methods",c("Subsampling","Bootsraping","Cross-Validation"),selected="Subsampling"),
                   numericInput("replicates1","Replicates",1,min=1),
                   numericInput("cv.folds1","CV.Folds1",5,min=1),
                   sliderInput('test.percent1','Test persentage',0,100,30,1)
    )
    # bsButton("run","Run!")
    # 
    
  ),
  mainPanel(
    h3(textOutput("caption")),
    tabsetPanel(position='above',
                tabPanel("Plot",plotOutput('mpgPlot')),
                tabPanel("Summary", verbatimTextOutput("summary")),
                tabPanel("Map", leafletOutput("mymap"),
                         p(),
                         actionButton("recalc", "New points"))
    )
  )
)
#library(shinyFiles)

# Author: Babak Naimi, naimi.b@gmail.com
# Date (last update):  July 2017
# Version 1.1
# Licence GPL v3

#-------------
methodInfo <- list(name=c('fda','FDA'),
                   packages='mda',
                   modelTypes = c('pa','pb','n'),
                   fitParams = list(formula='standard.formula',data='sdmDataFrame'),
                   fitSettings = list(method = substitute(polyreg),keep.fitted=FALSE),
                   fitFunction = 'fda',
                   settingRules = NULL,
                   tuneParams = list(method=substitute(c(polyreg,mars,gen.ridge,bruto))),
                   predictParams=list(object='model',newdata='sdmDataFrame'),
                   predictSettings=list(type='posterior'),
                   predictFunction=function(object,newdata,type) {
                     predict(object,newdata,type=type)[,'1']
                   },
                   #------ metadata (optional):
                   title='Flexible Discriminant Analysis',
                   creator='Babak Naimi',
                   authors=c('Trevor Hastie; Robert Tibshirani'), # authors of the main method
                   email='naimi.b@gmail.com',
                   url='http://r-gis.net',
                   citation=list(bibentry('Article',title = "Flexible Disriminant Analysis by Optimal Scoring",
                                          author = as.person("T. Hastie [aut], R. Tibshirani [aut], Buja [aut]"),
                                          year='1994',
                                          journal = "JASA",
                                          pages="1255-1270"
                   )
                   ),
                   description='Flexible discriminant analysis.'
)

# Author: Babak Naimi, naimi.b@gmail.com
# Date (last update) :  Nov. 2016
# Version 1.1
# Licence GPL v3

#-------------
methodInfo <- list(name=c('bioclim.dismo','BioclimDismo','bioclimDismo','bioclim.dis','bioclimD'),
                   packages=c('dismo'),
                   modelTypes = c('po'),
                   fitParams = list(formula='standard.formula',data='sdmDataFrame'),
                   fitSettings = NULL,
                   fitFunction = '.bioclimDismo',
                   settingRules = NULL,
                   tuneParams = NULL,
                   predictParams=list(object='model',x='sdmDataFrame'),
                   predictSettings=NULL,
                   predictFunction='predict',
                   #------ metadata (optional):
                   title='Bioclim',
                   creator='Babak Naimi',
                   authors=c('Robert J. Hijmans'), # authors of the main method
                   email='naimi.b@gmail.com',
                   url='http://r-gis.net',
                   citation=list(bibentry('Article',title = "Testing the ability of climate envelope models to predict the effect of climate change on species distributions",
                                          author = as.person("R. J. Hijmans [aut], C.H. Graham [aut]"),
                                          year='2006',
                                          number='12',
                                          pages='2272-2281',
                                          journal = "Global change biology"
                                          
                   )
                   ),
                   description="Build a 'Bioclim' (climate-envelope-model) species distribution model."
)

# Author: Babak Naimi, naimi.b@gmail.com
# Date (last update):  July 2017
# Version 1.1
# Licence GPL v3

#-------------
methodInfo <- list(name=c('cart','CART','tree'),
                   packages='tree',
                   modelTypes = c('pa','pb','ab','n'),
                   fitParams = list(formula='standard.formula',data='sdmDataFrame'),
                   fitSettings = list(method = "recursive.partition",split = "deviance",x=FALSE,y=FALSE,wts=FALSE,model=FALSE),
                   fitFunction = 'tree',
                   settingRules = NULL,
                   tuneParams = NULL,
                   predictParams=list(object='model',newdata='sdmDataFrame'),
                   predictSettings=list(type='vector'),
                   predictFunction='predict',
                   #------ metadata (optional):
                   title='Classification or Regression Tree',
                   creator='Babak Naimi',
                   authors=c('B. D. Ripley'), # authors of the main method
                   email='naimi.b@gmail.com',
                   url='http://r-gis.net',
                   citation=list(bibentry('book',title = "Classification and Regression Trees",
                                          author = as.person("L. Breiman [aut], J.H. Friedman [aut], R.A. Olshen [aut], C.J. Stone [aut]"),
                                          year='1984',
                                          publisher = "Wadsworth"
                   )
                   ),
                   description='A tree is grown by binary recursive partitioning using the response in the specified formula and choosing splits from the terms of the right-hand-side'
)

# Author: Babak Naimi, naimi.b@gmail.com
# Date :  March. 2016
# last update: April 2018
# Version 1.3
# Licence GPL v3

#-------------
methodInfo <- list(name=c('glmnet','GLMNET','glmelastic','glmlasso'),
                   packages='glmnet',
                   modelTypes = c('pa','pb','ab','n'),
                   fitParams = list(formula='standard.formula',data='sdmDataFrame'),
                   fitSettings = list(family='binomial',alpha=1),
                   fitFunction = function(formula,data,family,...) {
                     x <- .getData.sdmMatrix(formula,data,normalize=TRUE)
                     y <- .getData.sdmY(formula,data)
                     if (family == 'binomial') m <- cv.glmnet(x,y,family="binomial",type.measure = 'auc')
                     else m <- cv.glmnet(x,y,family=family)
                     glmnet(x=x,y=y,family=family,lambda=m$lambda.1se,...)
                   },
                   settingRules = function(x='sdmVariables',f='fitSettings') {
                     if (x@distribution %in% c('poisson','multinomial')) {
                       f[['family']] <- x@distribution
                     }
                     list(fitSettings=f)
                   },
                   tuneParams = NULL,
                   predictParams=list(object='model',formula='standard.formula',newx='sdmDataFrame'),
                   predictSettings=list(type='response'),
                   predictFunction=function(object,formula,newx,type) {
                     newx <- .getData.sdmMatrix(formula,newx,normalize=TRUE)
                     predict.glmnet(object,newx,type=type)[,1]
                   },
                   #------ metadata (optional):
                   title='GLM with lasso or elasticnet regularization',
                   creator='Babak Naimi',
                   authors=c('Jerome Friedman, Trevor Hastie, Noah Simon and Rob Tibshirani'), # authors of the main method
                   email='naimi.b@gmail.com',
                   url='http://r-gis.net',
                   citation=list(bibentry('Article',title = "Regularization Paths for Generalized Linear Models via Coordinate Descent,",
                                          author = as.person("J. Friedman [aut], T. Hastie [aut], R. Tibshirani [aut]"),
                                          year='2008',
                                          journal = "Journal of Statistical Software",
                                          number="33/1",
                                          pages="1-22"
                   )
                   ),
                   description="Fit a generalized linear model via penalized maximum likelihood. The regularization path is computed for the lasso or elasticnet penalty at a grid of values for the regularization parameter lambda."
)

# Author: Babak Naimi, naimi.b@gmail.com
# Date (last update):  Feb 2024
# Version 1.4
# Licence GPL v3

#-------------
methodInfo <-list(name=c('gam','GAM'),
           packages='mgcv',
           modelTypes = c('pa','pb','ab','n'),
           fitParams = list(v='sdmVariables',data='data.frame'),
           fitSettings = list(family=binomial(link='logit'),k=-1,bs='tp',weights=NULL,subset=NULL,na.action='na.omit',offset=NULL,method='GCV.Cp',optimizer=c("outer","newton"),select=FALSE,knots=NULL,sp=NULL,min.sp=NULL,H=NULL,gamma=1,fit=TRUE,paraPen=NULL,G=NULL),
           fitFunction = function(v,data,k=-1,bs='tp',...) {
             .f <- .getFormula.gammgcv(n=c(v@response,v@variables$numeric),nFact = v@variables$nFact,k=k,bs=bs)
             gam(formula = .f, data = data,...)
           },
           settingRules = function(x='sdmVariables',f='fitSettings') {
             if (x@distribution == 'poisson') f[['family']] <- x@distribution
             else if (x@distribution == 'multinomial') f[['family']] <- 'multinom'
             
             list(fitSettings=f)
           },
           tuneParams = NULL,
           predictParams=list(object='model',newdata='data.frame'),
           predictSettings=list(type='response'),
           predictFunction='predict.gam',
           #------ metadata (optional):
           title='Generalized Additive Models with integrated smoothness estimation',
           creator='Babak Naimi',
           authors=c('Simon N. Wood'), # authors of the main method
           email='naimi.b@gmail.com',
           url='http://r-gis.net',
           citation=list(bibentry('book',title = " Generalized Additive Models: An Introduction with R",
                                  author = as.person("S. N. Wood [aut]"),
                                  year = "2006",
                                  publisher = "Chapman and Hall/CRC press")
           ),
           description='Fits a generalized additive model (GAM) to data, the term "GAM" being taken to include any quadratically penalized GLM and a variety of other models estimated by a quadratically penalised likelihood type approach [see the help for gam function in mgcv package]'
)
#------------

# Author: Babak Naimi, naimi.b@gmail.com
# Date :  April 2018
# last update: March 2019
# Version 1.1
# Licence GPL v3

#-------------
methodInfo <- list(name=c('mlp','MLP','nnet.mlp','nnetMLP'),
                   packages='RSNNS',
                   modelTypes = c('pa','pb','ab','n'),
                   fitParams = list(formula='standard.formula',data='sdmDataFrame'),
                   fitSettings = list(size=10,maxit=500),
                   fitFunction = function(formula,data,...) {
                     x <- .getData.sdmMatrix(formula,data,normalize=TRUE)
                     y <- .getData.sdmY(formula,data)
                     mlp(x=x,y=y,...)
                   },
                   settingRules = NULL,
                   tuneParams = NULL,
                   predictParams=list(object='model',formula='standard.formula',newx='sdmDataFrame'),
                   predictSettings=NULL,
                   predictFunction=function(object,formula,newx) {
                     newx <- .getData.sdmMatrix(formula,newx,normalize=TRUE)
                     predict(object,newx)[,1]
                   },
                   #------ metadata (optional):
                   title='multilayer perceptron (MLP) network',
                   creator='Babak Naimi',
                   authors=c("Christoph Bergmeir et al. (for the package RSNNS)"), # authors of the main method
                   email='naimi.b@gmail.com',
                   url='http://r-gis.net',
                   citation=list(bibentry(bibtype='Manual',title = "SNNS Stuttgart Neural Network Simulator User Manual",
                                          author = person("A. Zell, [aut]"),
                                          year='1998',
                                          organization="University of Stuttgart and WSI, University of Tübingen"
                   )
                   ),
                   description="MLP is a type of Neural Network, a fully connected feedforward networks, and probably the most common network architecture in use."
)

# Author: Babak Naimi, naimi.b@gmail.com
# Date (last update):  July 2017
# Version 1.1
# Licence GPL v3

#-------------
methodInfo <- list(name=c('bioclim','Bioclim'),
                   packages=NULL,
                   modelTypes = c('po'),
                   fitParams = list(formula='standard.formula',data='sdmDataFrame'),
                   fitSettings = list(c=2,weights=NULL),
                   fitFunction = '.bioclimFit',
                   settingRules = NULL,
                   tuneParams = NULL,
                   predictParams=list(object='model',newdata='sdmDataFrame'),
                   predictSettings=NULL,
                   predictFunction='predict',
                   #------ metadata (optional):
                   title='Model occurrence probability using presence-only data',
                   creator='Babak Naimi',
                   authors=c('Babak Naimi'), # authors of the main method
                   email='naimi.b@gmail.com',
                   url='http://r-gis.net',
                   citation=list(bibentry('Article',title = "sdm: a reproducible and extensible R platform for species distribution modelling",
                                          author = as.person("B. Naimi [aut], M.B. Araujo [aut]"),
                                          year='2016',
                                          journal = "Ecography"
                                          
                   )
                   ),
                   description="Estimates habitat suitability using presence-only data"
)

# Author: Babak Naimi, naimi.b@gmail.com
# Date :  Jan 2024
# last update: Jan 2024
# Version 1.1
# Licence GPL v3
#-------------

methodInfo <- list(name=c('maxNet','maxnet','mnet','mNet'),
                   packages='maxnet',
                   modelTypes = c('pb'),
                   fitParams = list(formula='standard.formula',data='sdmDataFrame'),
                   fitSettings = list(f=NULL,regfun = NULL ,regmult = 1,addsamplestobackground=TRUE),
                   fitFunction = '.maxNet',
                   settingRules = NULL,
                   tuneParams = NULL,
                   predictParams=list(object='model',newdata='sdmDataFrame'),
                   predictSettings=list(type='cloglog'),
                   predictFunction='predict',
                   #------ metadata (optional):
                   title='Model Maxent over glmnet',
                   creator='Babak Naimi',
                   authors=c('Steven Phillips'), # authors of the main method
                   email='naimi.b@gmail.com',
                   url='http://r-gis.net',
                   citation=list(bibentry('Article',title = "Opening the black box: An open‐source release of Maxent",
                                          author = as.person("S. Phillips [aut] et al."),
                                          year='2017',
                                          journal = "Ecography"
                                          
                   )
                   ),
                   description="Procedures to fit species distributions models from occurrence records and environmental variables, using 'glmnet' for model fitting."
)

.trainCheckVars <- function(train) {
  nnFact <- nnf <- nnxy <- nnt <- NULL
  w <- sdm:::.speciesDetect(train)
  if (!is.null(w$nFact)) {
    nFact <- w$nFact
    nnFact <- paste(paste('f(',w$nFact,')',sep=''),collapse='+')
  }
  if (!is.null(w$nf)) {
    nf <- w$nf
    nnf <- paste(w$nf,collapse='+')
  }
  if (!is.null(w$nxy)) {
    nxy <- w$nxy
    nnxy <- paste(paste('coords(',paste(w$nxy,collapse='+'),')',sep=''),collapse='+')
  }
  if (!is.null(w$nt)) {
    nt <- w$nt
    nnt <- paste(paste('time(',w$nt,')',sep=''),collapse='+')
  }
  formula <- as.formula(paste(paste(w$nsp,collapse="+"),'~',paste(c(nnf,nnFact,nnxy,nnt),collapse='+')),env = parent.frame())
  c(formula=formula,w)
}


#.trainCheckVars(data.frame(sp=c(1,1,1,0,0),a1=c(1,2,3,4,5),b=c('a','b','c','d','e')))



server <- function(input, output,session) {
  #----- ShiyFiles--------
  volumes <- c(wd='.',getVolumes()())
  
  shinyFileChoose(input, 'trainFile',session=session,roots=volumes, filetypes=c('', 'csv','txt','shp','sdd','rds'))
  shinyFileChoose(input, 'predFiles',session=session,roots=volumes, filetypes=c('','grd', 'tif','img','bil','asc','rst','nc','envi'))
  shinyFileChoose(input, 'testFile',session=session,roots=volumes, filetypes=c('', 'csv','txt','shp'))
  
  observeEvent(input$trainFile$files, {
    trainName <- as.character(parseFilePaths(volumes,input$trainFile)[1,4])
    updateTextInput(session,"trainFileName",value=trainName)
    ext <- strsplit(trainName,'[.]')[[1]]
    ext <- ext[length(ext)]
    if (ext == 'csv') {
      train <- read.csv(trainName)
    } else if (ext == 'shp') {
      train <- shapefile(trainName)
    } else if (ext == 'txt') {
      train <- read.table(trainName,header = TRUE,sep='\t')
    } else if (ext == 'sdd') {
      train <- read.sdm(trainName)
    } else if (ext == 'rds') {
      train <- readRDS(trainName)
    }
    if (class(train) == 'data.frame') {
      # output$dynSpecies <- renderUI({
      #   checkboxGroupInput("chk","Select species",colnames(train))
      # })
      # output$dynPreds <- renderUI({
      #   checkboxGroupInput("chk","Select predictors",colnames(train))
      # })
      output$dynSpecies <- renderUI({
        # If missing input, return to avoid error later in function
        # Create the checkboxes and select them all by default
        checkboxGroupInput("columns", "Choose columns", 
                           choices  = names(train),
                           selected = names(train))
      })
      
      # output$dynPreds <- renderTable({
      #   # If missing input, return to avoid error later in function
      #   # Keep the selected columns
      #   train <- train[, input$columns, drop = FALSE]
      #   
      #   # Return first 20 rows
      #   head(train, 20)
      # })
      # 
      output$tbl <- DT::renderDataTable({
        df <- data.frame(
          varNames=colnames(train),
          Linear=rep(TRUE,length(colnames(train))),
          Quadratic=rep(FALSE,length(colnames(train))),
          Cubic=rep(FALSE,length(colnames(train)))
        )
        addCheckboxButtons <- paste0('<input type="checkbox" name="row', df$Linear, '" value="', df$Linear, '" checked="1">',"")
        
        DT::datatable(cbind(select=addCheckboxButtons, df), options = list(searching=FALSE, paging=FALSE, ordering=FALSE,
                                                                           columnDefs=list(list(className='dt-center', targets=c(0,2)))),
                      callback = "function(table) {
                      table.on('change.dt', 'tr td input:checkbox', function() {
                      setTimeout(function () {
                      Shiny.onInputChange('varRows', $(this).add('tr td input:checkbox:checked').parent().siblings(':nth-child(2)').map(function() {
                      return $(this).text();
                      }).get())
                      }, 10);
                      }); 
      }", escape=FALSE) 
    })
      
    } else if (class(train) == 'SpatialPointsDataFrame') {
      output$dynSpecies <- renderUI({
        checkboxGroupInput("chk","Select species",colnames(train))
      })
    }
  }
  )
  
  observeEvent(input$predFiles$files, {
    updateTextInput(session,"predFileNames",value=as.character(parseFilePaths(volumes,input$predFiles)[,4]))
  }
  )
  
  observeEvent(input$trainFile$files, {
    updateTextInput(session,"testFileName",value=as.character(parseFilePaths(volumes,input$testFile)[1,4]))
  }
  )
  #---------------
  #################
  
  
  
  observe({
    if (input$format == 'CSV') {
      updateSelectizeInput(session,"train",choices=list.files(pattern='.csv$'))
    } else if (input$format == 'SHP') {
      updateSelectizeInput(session,"train",choices=list.files(pattern='.shp$'))
    }
    updateSelectizeInput(session,"predictors",choices=list.files(pattern='grd$'),selected='')
    #if (input$run != 0) updateButton(session,'run',value=0)
    
  })
  
  train <- reactive({
    #     if (is.null(input$train)) retrun(NULL)
    #     else {
    #       ext <- strsplit(input$train,'[.]')[[1]]
    #       ext <- ext[length(ext)]
    #       if (ext == 'csv') {
    #         return(read.csv(input$train))
    #       } else if (ext == 'shp') {
    #         return(readShapeSpatial(input$train))
    #       } else return (NULL)
    #     }
    if (input$format == 'CSV') {
      return(read.csv(input$train))
    } else if (input$format == 'SHP') {
      return(readShapeSpatial(input$train))
    }
    
  })
  preds <- reactive({
    if (input$predictors != '') {
      return(brick(input$predictors))
    } else return (NULL)
  })
  
  method <- reactive({
    paste(input$methods,collapse=', ')
  })
  #shinyFileChoose(input, 'files', session=session,roots=c(wd='.'), filetypes=c('', '.txt'))
  ss <- reactive({
    if (!input$run) return (NULL)
    if (!is.null(train)) {
      if (is.null(preds())) d <- sdmData(train())
      else d <- sdmData(train=train(),predictors = preds())
    }
    f <- as.formula(paste(d@train@Occurrence@species.name,'~.'))
    sdm(f,d,methods = input$methods,test.perc=input$test.percent,replicate.method=input$repMethod,replicates=as.numeric(input$replicates),cv.folds=as.numeric(input$cv.folds))
    
    
  })
  output$caption <- renderText({
    if (!is.null(ss())) method()
  })
  
  output$summary <- renderPrint({
    if (!is.null(ss())) show(ss())
  })
  
  
  output$mpgPlot <- renderPlot({
    #s <- sdm(Occurrence~.,d,methods = input$methods,test.perc=input$test.percent,replicate.method=input$repMethod)
    #roc(s)
    #if (!is.null(ss())) roc(ss())
  })
  
  output$mymap <- renderLeaflet({
    leaflet() %>%
      addTiles() %>%
      #addMarkers(data = points())
      addMarkers(lng=174.768, lat=-36.852, popup="The birthplace of R")
  })
  
}

# Author: Babak Naimi, naimi.b@gmail.com
# Date (last update):  July 2017
# Version 1.1
# Licence GPL v3

#-------------
methodInfo <- list(name=c('mars','MARS','earth'),
                   packages='earth',
                   modelTypes = c('pa','pb','ab','n'),
                   fitParams = list(formula='standard.formula',data='sdmDataFrame'),
                   fitSettings = list(weights=NULL,pmethod='none',trace=0,glm=list(family=binomial)),
                   fitFunction = 'earth',
                   settingRules = function(x='sdmVariables',f='fitSettings') {
                     if (x@distribution == 'poisson') f[['glm']] <- list(family=poisson)
                     list(fitSettings=f)
                   },
                   tuneParams = list(glm=c(NULL,'default')),
                   predictParams=list(object='model',newdata='sdmDataFrame'),
                   predictSettings=list(type='response'),
                   predictFunction='predict',
                   #------ metadata (optional):
                   title='Multivariate Adaptive Regression Splines',
                   creator='Babak Naimi',
                   authors=c('Stephen Milborrow'), # authors of the main method
                   email='naimi.b@gmail.com',
                   url='http://r-gis.net',
                   citation=list(bibentry('Article',title = "Multivariate Adaptive Regression Splines",
                                          author = as.person("Friedman [aut]"),
                                          year='1991',
                                          journal = "Annals of Statistics",
                                          number="19/1",
                                          pages="1-141"
                   )
                   ),
                   description="Build a regression model using the techniques in Friedman's papers 'Multivariate Adaptive Regression Splines' and 'Fast MARS'."
)

# Author: Babak Naimi, naimi.b@gmail.com
# Date (last update):  Nov. 2021
# Version 1.3
# Licence GPL v3

#-------------
methodInfo <- list(name=c('svm','SVM','ksvm'),
                   packages='kernlab',
                   modelTypes = c('pa','pb','ab','n'),
                   fitParams = list(x='standard.formula',data='sdmDataFrame'),
                   fitSettings = list(type='C-svc',kernel='rbfdot',epsilon=0.1,prob.model=TRUE,tol=0.001,shrinking=TRUE),
                   fitFunction = 'ksvm',
                   settingRules = function(x='sdmVariables',f='fitSettings') {
                     if (x@distribution == 'multinomial') f[['type']] <- 'C-svc'
                     list(fitSettings=f)
                   },
                   tuneParams = NULL,
                   predictParams=list(object='model',newdata='sdmDataFrame'),
                   predictSettings=list(type='probabilities'),
                   predictFunction=function(object, newdata, type , coupler = "minpair") {
                     px <- predict(object,newdata,type=type,coupler=coupler)
                     if (ncol(px) == 2) px[,2]
                     else px
                   },
                   #------ metadata (optional):
                   title='Support Vector Machines',
                   creator='Babak Naimi',
                   authors=c('Alexandros Karatzoglou'), # authors of the main method
                   email='naimi.b@gmail.com',
                   url='http://r-gis.net',
                   citation=list(bibentry('Article',title = "LIBSVM: a library for Support Vector Machines",
                                          author = as.person("C. Chih-Chung [aut], L. Chih-Jen [aut]"),
                                          year='2015',
                                          journal = "http://www.csie.ntu.edu.tw/~cjlin/libsvm"
                   )
                   ),
                   description='Support Vector Machines are an excellent tool for classification, novelty detection, and regression'
)

# Author: Babak Naimi, naimi.b@gmail.com
# Date (last update):  July 2017
# Version 1.1
# Licence GPL v3

#-------------


methodInfo <-list(name=c('glm','GLM','lm'),
           packages='stats',
           modelTypes = c('pa','pb','ab','n'),
           fitParams = list(formula='standard.formula',data='sdmDataFrame'),
           fitSettings = list(family=binomial(link='logit'),weights=NULL,model=FALSE),
           fitFunction = 'glm',
           settingRules = function(x='sdmVariables',f='fitSettings') {
             if (x@distribution %in% c('poisson','multinomial')) {
               f[['family']] <- x@distribution
             }
             list(fitSettings=f)
           },
           tuneParams = NULL,
           predictParams=list(object='model',newdata='sdmDataFrame'),
           predictSettings=list(type='response'),
           predictFunction='predict.glm',
           #------ metadata (optional):
           title='Generalized Linear Model',
           creator='Babak Naimi',
           authors=c('R Core team'), # authors of the main method
           email='naimi.b@gmail.com',
           url='http://r-gis.net',
           citation=list(bibentry('book',title = "Generalized linear models",
                                  author = as.person("P. McCullagh [aut], J. A. Nelder [aut]"),
                                  year = "1989",
                                  publisher = "Chapman and Hall",
                                  address = "London")
           ),
           description='glm is used to fit generalized linear models, specified by giving a symbolic description of the linear predictor and a description of the error distribution [see the help for glm function in stats package]'
)

# Author: Babak Naimi, naimi.b@gmail.com
# Date (last update):  July 2017
# Version 1.1
# Licence GPL v3

#-------------
methodInfo <- list(name=c('rpart','RPART'),
                   packages='rpart',
                   modelTypes = c('pa','pb','ab','n'),
                   fitParams = list(formula='standard.formula',data='sdmDataFrame'),
                   fitSettings = list(model=FALSE,x=FALSE,y=FALSE,method='anova'),
                   fitFunction = 'rpart',
                   settingRules = function(x='sdmVariables',f='fitSettings',p='predictSettings') {
                     if (x@distribution == 'poisson') {
                       f[['method']] <- 'poisson'
                     } else if (x@distribution == 'multinomial') {
                       f[['method']] <- 'class'
                       p[['type']] <- 'class'
                     }
                     list(fitSettings=f,predictSettings=p)
                   },
                   tuneParams = NULL,
                   predictParams=list(object='model',newdata='sdmDataFrame'),
                   predictSettings=list(type='vector'),
                   predictFunction='predict',
                   #------ metadata (optional):
                   title='Recursive Partitioning and Regression Trees',
                   creator='Babak Naimi',
                   authors=c('Terry Therneau, Beth Atkinson, Brian Ripley'), # authors of the main method
                   email='naimi.b@gmail.com',
                   url='http://r-gis.net',
                   citation=list(bibentry('book',title = "Classification and Regression Trees",
                                          author = as.person("L. Breiman [aut], J.H. Friedman [aut], R.A. Olshen [aut], C.J. Stone [aut]"),
                                          year='1984',
                                          publisher = "Wadsworth"
                   )
                   ),
                   description="Recursive Partitioning and Regression Trees."
)

# Author: Babak Naimi, naimi.b@gmail.com
# Date (last update):  July 2017
# Version 1.1
# Licence GPL v3

#-------------
methodInfo <- list(name=c('rf','RF','randomForest','rforest'),
                   packages='randomForest',
                   modelTypes = c('pa','pb','ab','n'),
                   fitParams = list(formula='standard.formula',data='sdmDataFrame'),
                   fitSettings = list(ntree=1000,
                                      replace=TRUE,
                                      importance=TRUE
                   ),
                   fitFunction = 'randomForest',
                   settingRules = NULL,
                   tuneParams = NULL,
                   predictParams=list(object='model',newdata='sdmDataFrame'),
                   predictSettings=list(type='response'),
                   predictFunction='predict',
                   #------ metadata (optional):
                   title='Random Forest',
                   creator='Babak Naimi',
                   authors=c('Andy Liaw','Matthew Wiener'), # authors of the main method
                   email='naimi.b@gmail.com',
                   url='http://r-gis.net',
                   citation=list(bibentry('Article',title = "Random Forests",
                                          author = as.person("L. Breiman [aut]"),
                                          year = "2001",
                                          journal = "Machine Learning",
                                          number="45(1)",
                                          pages="5-32"
                   )
                   ),
                   description="implements Breiman's random forest algorithm (based on Breiman and Cutler's original Fortran code) for classification and regression."
)

# Author: Babak Naimi, naimi.b@gmail.com
# Date :  Sep 2015
# Version 1.0
# Licence GPL v3

if (!isGeneric("gui")) {
  setGeneric("gui", function(...)
    standardGeneric("gui"))
}


setMethod('gui', signature('ANY'), 
          function(...) {
            l <- c(require(shiny),require(shinythemes),require(shinyBS),require(leaflet))
            if (!all(l)) stop(paste(paste(c('shiny','shinythemes','shinyBS','leaflet')[l],collapse=', '),'are required but not installed!'))
            
            #shiny::runApp(system.file('shinyApps/sdm_base', package='sdm'))
            shinyApp(
              ui=fluidPage(theme=shinytheme("Flatly"),
                           
                           #headerPanel(img(src="r_terminal_sdm.png", height = 300, width = 900)),
                           #br(),
                           
                           HTML ('<div style="background-color:black; color:white; margin:10px; padding:10px;">
                                 <h2>> library(sdm)</h2>
                                 <p>
                                 A framework to model and simulate species distributions
                                 </p>
                                 </div>'
                           ),
                           #     
                           
                           
                           sidebarPanel(
                             bsCollapsePanel("Data Settings",
                                             radioButtons('format','Input Train Data Format',c('CSV','SHP')),
                                             selectizeInput("train","Select Train Dataset:","NULL"),
                                             hr(),
                                             selectizeInput("predictors","Select Raster Predictors file","NULL"),
                                             br(),
                                             br()
                                             
                             ),
                             # shinyFilesButton('files', label='File select', title='Please select a file', multiple=FALSE),
                             bsCollapsePanel("Models Settings",
                                             checkboxGroupInput("methods","Methods",c("GLM","GAM","BRT","RF","SVM","MARS","NNet","Bioclim","Domin","Mahalanobis","Maxent","Maxlike","Ensemble"),inline=T, selected="GLM"),
                                             hr(),
                                             checkboxGroupInput("repMethod","Replication Methods",c("Subsampling","Bootsraping","Cross-Validation"),selected="Subsampling"),
                                             numericInput("replicates","Replicates",1,min=1),
                                             numericInput("cv.folds","CV.Folds",5,min=1),
                                             sliderInput('test.percent','Test persentage',0,100,30,1)
                             ),
                             bsToggleButton("run","Run!")
                             
                             
                           ),
                           mainPanel(
                             h3(textOutput("caption")),
                             tabsetPanel(position='above',
                                         tabPanel("Plot",plotOutput('mpgPlot')),
                                         tabPanel("Summary", verbatimTextOutput("summary")),
                                         tabPanel("Map", leafletOutput("mymap"),
                                                  p(),
                                                  actionButton("recalc", "New points"))
                             )
                           )
                           ),
              server=function(input, output,session) {
                observe({
                  if (input$format == 'CSV') {
                    updateSelectizeInput(session,"train",choices=list.files(pattern='.csv$'))
                  } else if (input$format == 'SHP') {
                    updateSelectizeInput(session,"train",choices=list.files(pattern='.shp$'))
                  }
                  updateSelectizeInput(session,"predictors",choices=list.files(pattern='grd$'),selected='')
                  #if (input$run != 0) updateButton(session,'run',value=0)
                  
                })
                train <- reactive({
                  #     if (is.null(input$train)) retrun(NULL)
                  #     else {
                  #       ext <- strsplit(input$train,'[.]')[[1]]
                  #       ext <- ext[length(ext)]
                  #       if (ext == 'csv') {
                  #         return(read.csv(input$train))
                  #       } else if (ext == 'shp') {
                  #         return(readShapeSpatial(input$train))
                  #       } else return (NULL)
                  #     }
                  if (input$format == 'CSV') {
                    return(read.csv(input$train))
                  } else if (input$format == 'SHP') {
                    return(readShapeSpatial(input$train))
                  }
                  
                })
                preds <- reactive({
                  if (input$predictors != '') {
                    return(brick(input$predictors))
                  } else return (NULL)
                })
                
                method <- reactive({
                  paste(input$methods,collapse=', ')
                })
                #shinyFileChoose(input, 'files', session=session,roots=c(wd='.'), filetypes=c('', '.txt'))
                ss <- reactive({
                  if (!input$run) return (NULL)
                  if (!is.null(train)) {
                    if (is.null(preds())) d <- sdmData(train())
                    else d <- sdmData(train=train(),predictors = preds())
                  }
                  f <- as.formula(paste(d@train@Occurrence@species.name,'~.'))
                  sdm(f,d,methods = input$methods,test.perc=input$test.percent,replicate.method=input$repMethod,replicates=as.numeric(input$replicates),cv.folds=as.numeric(input$cv.folds))
                  
                  
                })
                output$caption <- renderText({
                  if (!is.null(ss())) method()
                })
                
                output$summary <- renderPrint({
                  if (!is.null(ss())) show(ss())
                })
                
                
                output$mpgPlot <- renderPlot({
                  #s <- sdm(Occurrence~.,d,methods = input$methods,test.perc=input$test.percent,replicate.method=input$repMethod)
                  #roc(s)
                  if (!is.null(ss())) roc(ss())
                })
                
                output$mymap <- renderLeaflet({
                  leaflet() %>%
                    addTiles() %>%
                    #addMarkers(data = points())
                    addMarkers(lng=174.768, lat=-36.852, popup="The birthplace of R")
                })
                
              }
              
              )
          }
)

# Author: Babak Naimi, naimi.b@gmail.com
# Date :  July 2017
# Version 1.1
# Licence GPL v3

#-------------
methodInfo <- list(name=c('maxlike','MaxLike'),
                   packages=NULL,
                   modelTypes = c('pb'),
                   fitParams = list(formula='standard.formula',data='sdmDataFrame'),
                   fitSettings = list(link='logit',hessian=TRUE,normalize=TRUE),
                   fitFunction = '.maxlike',
                   settingRules = NULL,
                   tuneParams = NULL,
                   predictParams=list(object='model',newdata='sdmDataFrame'),
                   predictSettings=NULL,
                   predictFunction='predict',
                   #------ metadata (optional):
                   title='Model occurrence probability using presence-only data',
                   creator='Babak Naimi',
                   authors=c('Richard Chandler and Andy Royle'), # authors of the main method
                   email='naimi.b@gmail.com',
                   url='http://r-gis.net',
                   citation=list(bibentry('Article',title = "Likelihood analysis of species occurrence probability from presence-only data for modelling species distributions",
                                          author = as.person("J.A. Royle [aut], R.B. Chandler [aut], C. Yackulic [aut], J. D. Nichols [aut]"),
                                          year='2012',
                                          journal = "Methods in Ecology and Evolution"
                                          
                   )
                   ),
                   description="Estimates the probability of occurrence using presence-only data and covariates as background data."
)

# Author: Babak Naimi, naimi.b@gmail.com
# Date :  September 2015
# Version 1.0
# Licence GPL v3

if (!isGeneric("pca")) {
  setGeneric("pca", function(x,...)
    standardGeneric("pca"))
}


setMethod('pca', signature(x='singleSpecies'), 
          function(x,...) {
            n <- x@train@Features@featureNames
            x <- as.data.frame(x)[,n]
            d <- princomp(x,...)
            for (i in 1:length(n)) x[,i] <- d$scores[,i]
            colnames(x) <- colnames(d$scores)
            list(data=x,pca=d)
          }
)
          

setMethod('pca', signature(x='multipleSpecies'), 
          function(x,...) {
            n <- x@train@Features@featureNames
            x <- as.data.frame(x)[,n]
            d <- princomp(x,...)
            for (i in 1:length(n)) x[,i] <- d$scores[,i]
            colnames(x) <- colnames(d$scores)
            list(data=x,pca=d)
          }
)



setMethod('pca', signature(x='RasterStackBrick'), 
          function(x,...) {
            n <- nlayers(x)
            nc <- 1:ncell(x)
            nc <- nc[which(!is.na(x[[1]][]))]
            d <- x[nc]
            d <- princomp(d,...)
            for (i in 1:n) x[[i]][nc] <- d$scores[,i]
            names(x) <- colnames(d$scores)
            list(data=x,pca=d)
          }
)

---
title: "getting started with sdm package"
author: "Babak Naimi, Miguel B. Araujo"
date: "3 April 2016"
output: rmarkdown::html_vignette

vignette: >
  %\VignetteIndexEntry{getting started with sdm package}
  %\VignetteEngine{knitr::rmarkdown}
  %\usepackage[utf8]{inputenc}
---

sdm is an object-oriented, reproducible and extensible R platform for species distribution modelling. The sdm package is designed to create a comprehensive modelling and simulation framework that: 1) provides a standardised and unified structure for handling species distributions data and modelling techniques (e.g. a unified interface is used to fit different models offered by different packages); 2) is able to support markedly different modelling approaches; 3) enables scientists to modify the existing methods, extend the framework by developing new methods or procedures, and share them to be reproduced by the other scientists; 4) handles spatial as well as temporal data for single or multiple species; 5) employs high performance computing solutions to speed up modelling and simulations, and finally; 6) uses flexible and easy-to-use GUI interface. For more information, check the published paper by Naimi and Araujo (2016) in the journal of Ecography.

This document provides a very quick demonstration on the package followed by some examples, that would be helpful to get a guick start with the package.

## Installing sdm and all the required packages

sdm can simply be installed using the standard install.packages function as:

install.packages('sdm')

Depending on the methods are selected through the modelling and using the package, several packages may be needed, and therefore, should be installed on your machine. A quick way to install all the required packages (to guarantee having full functionaliy of sdm), is to simply use the function **installAll** offered by the sdm package. You can simply call it without any argument:

installAll()

## A brief overview:

There are three main functions provide the main steps of developing/using species distibution models. The three steps include data preparation, model fitting/ evaluation, and prediction. The functions used for these steps:

* \textbf{sdmData}: to read data from different formats, and prepare a data object. Both species (single or multiple) and explanatory variables can be introduced to the function, as well as other information such as spatial coordinates, time, grouping variables, etc.

* \textbf{sdm}: to fit and evaluate species distribution models (multiple algorithms can be used)

* \textbf{predict}: when models are fitted, they can be used to predict/project given a new dataset.


## Example Dataset:

The package is followed by several datasets that are used in the help pages. We also use one of those examples here for our demonstration:

We use a shapefile containing presence=absence records for a species as spatial points (species.shp), and four raster datasets (in Ascii format) as explanatory variables (predictors). The files are in the sdm library, so we can directly read them from the library folder. We use rgdal to read raster data (it supports different common formats), and raster package to handle the raster data.

```{r,  echo=FALSE, results='hide',message=FALSE}
library(sdm)

library(raster)
library(rgdal)

sdm:::.addMethods()

```
```{r, fig.width = 6, fig.height = 6}
library(sdm)

library(raster)
library(rgdal)

file <- system.file("external/species.shp", package="sdm") # get the location of the species shapefile in the sdm package

# so, file is simply a filename (with path):
file
# read the species shapefile using the function shapefile:

species <- shapefile(file)

class(species) # it is a SpatialPointsDataFrame

plot(species)
# we can take a look at the head of attribute table in the species dataset:

head(species)

# you can see that there is a column has presence-absence records (name of column is important to know: Occurrence)

#--- we can plot presence and absence points separately with different colours:

plot(species[species$Occurrence == 1,],col='blue',pch=16)

points(species[species$Occurrence == 0,],col='red',pch=16)

##########
# Let's read predictor variables (raster datasets)
# We have four Ascii-Grids, so, let's just take the name of all files ending to '.asc' to be able to read them together. list.files function can be used to get a list of files in a given path:

path <- system.file("external", package="sdm") # path to the folder contains the data
lst <- list.files(path=path,pattern='asc$',full.names = T) # list the name of files in the specified path, match the pattern (means all files with a name ending to asc). We asked to generate full names (i.e., names with the path)

lst # this is the name of raster files we want to use as predictor variables

# stack is a function in the raster package, to read/create a multi-layers raster dataset
preds <- stack(lst) # making a raster object

preds # see the specification of the raster layers (e.g., cell size, extent, etc.)

plot(preds)

plot(preds[[4]]) # only plot the 4th layer

plot(species,add=T) # let's add the species point on the previous plot


```

## Data preparation
So far, we used other packages to just read the data we need to use in our study. Now, we can use the sdm package. First, we need to read and put data in the package that creates a data object. This is very simple and efficient using the function \textbf{sdmData}. 

In this function, we can specify the train dataset (can be spatial points or simply a data.frame), and predictors (if available separately as a raster object). In addition, if there is an independent dataset available to be used for measuring model performance (evaluation/validation), we can provide it through the test arguement. A formula can also be used to specify the response and explanatory variables (and in case if you have data.frame as input which contains coordinates, you can specify the coordinates in the formula as well, + more information). If the formula is not specified, the function tries to detect the species and predictor variables.


```{r}
library(sdm)

d <- sdmData(formula=Occurrence~., train=species, predictors=preds)

d


# we didn't really need the formula in this example, as it would be easy for the function to guess which dataset is species, and which are predictors. So, it could be like this:
d <- sdmData(train=species, predictors=preds)

d

# However, formula makes it so flexible to handle the variables, specifally if there are several other information (e.g., time). If you have multiple species, you can have their names in the left hand side (e.g., sp1+sp2+sp3~.)

# You may also want to take part of variables:
d <- sdmData(formula=Occurrence~precipitation+temperature, train=species, predictors=preds)

d

d <- sdmData(formula= ~., train=species, predictors=preds)


#---


```
## Model Fitting and Evaluation


When you create the data object (d in the above example), you would be able to fit the models. To do so, you are going to use the function \textbf{sdm}. In this function, you can specify the variables and the type of features can be generated based on, through a formula. In addition, the name of methods can be specifies as well as settings.

```{r, fig.width = 6, fig.height = 4}
# in the following example, we use 3 different methods to fit the models.

m1 <- sdm(Occurrence~.,data=d,methods=c('glm','gam','brt'))

m1
# as you can see, a report is generates shows how many percent of models were successful, and their performance
#-------------------

# in the above example, the performance statistics were calculated based on the training dataset (the data that were used to fit the mdoel). It is a better idea to have an independent dataset (if so, we would specify in the test argument of sdmData). However, for most of cases, there is no such data available, therefore, we can split the dataset as an alternative solution. Splitting (partitioning) can be one time or several times (several replicates). There are also several methods to do that (i.e., subsampling, cross-validation, bootsrapping)

# Here we are going to fit 5 models and evaluate them through 2 runs of subsampling, each draw 30 percent of training data as test dataset:

m2 <- sdm(Occurrence~.,data=d,methods=c('rf','tree','fda','mars','svm'),replicatin='sub',test.percent=30,n=2)

m2

getModelInfo(m2) # info on runs including modelID, whether they are successfully fitted and evaluated, etc.


# We can generate the roc curve and compare the results for all models:
roc(m2)

# the plots can be smoothes:
roc(m2,smooth=T)
```


## Prediction

We can use the output of fitting, to predict into the study area, or project into a new location or a new time. 

The predict function can be used for this purpose:

```{r, fig.width = 6, fig.height = 6}
# in the following, we just predict the habitat suitability into the whole study area
# since the newdata is a raster object, the output is also a raster object

p1 <- predict(m1,newdata=preds,filename='p1.img') # many commonly used raster format is supported (through the package rgdal)

plot(p1)

p2 <- predict(m2,newdata=preds,filename='p2.img')

p2

nlayers(p2)

plot(p2[[1:4]]) # plot the first 12 rasters

# we can take the mean of raster over different runs for each method and species:
p2m <- predict(m2,newdata=preds,filename='p2m.img',mean=T)

p2m

plot(p2m)

# full names of rasters:
getZ(p2m)

```

## Reference

Naimi, B., Araujo, M.B. (2016) sdm: a reproducible and extensible R platform for species distribution modelling, Ecography, 39:368-375, DOI: 10.1111/ecog.01881
